/* TODO 
	Percent complete would be better if it included portion of current segment completed.
	Erase previous IDL's if desired.
	Lock model prior to entry and release lock after copying info.
	1/2 amp If classes are not ascending, sort causes reordering - need to preserve it.

*/

#include "stdafx.h"

#include "TaskAmpHistogram.h"
#include "HMM.h"


//----------------------------------------------------------------------
COptionsAmpHistogram :: COptionsAmpHistogram() { 
	m_iChannel=0;
	m_iChannels=1;
	m_iDataMode=0;
	m_iBins = 100;
	}
	
void COptionsAmpHistogram :: ToBuffer( BYTE * buf ){ 
	sprintf( (char * )buf, "1 %3d %3d %1d %4d", 
					min( m_iChannel, 999), min( m_iChannels, 999), 
					m_iDataMode, min( 9999, m_iBins ) );
	}
	
void COptionsAmpHistogram :: FromBuffer( BYTE * buf ){ 
	int iVer;
	sscanf( (char * )buf, "%d %d %d %d %d", 
				&iVer, &m_iChannel, &m_iChannels, &m_iDataMode, &m_iBins );
	}
	
bool COptionsAmpHistogram :: RegistryLoad( ) { 
	CString c = RegistryLoadString( "OPTIONSAMPHIST" ); 
	if( c.Length()==0 ) 
		return false;
	FromBuffer( (BYTE *)c.ConstBuffer() );
	return true;
	}
	
bool COptionsAmpHistogram :: RegistrySave( ) { 
	BYTE buf[BUF_AMPHIST_SIZE+64];
	ToBuffer( buf );
	return RegistrySaveString( "OPTIONSAMPHIST", (char *)buf );
	}

//----------------------------------------------------------------------
DWORD WINAPI TaskAmpHistogram( LPVOID pParam ) { 
	CVwTaskAmpHistogram * pVwTask = (CVwTaskAmpHistogram *) pParam;
	CSelectionSet * pSet = &(pVwTask->m_oSelSet);

	//----- Find min, max 
	double dMin, dMax;
	pSet->CalculateMinMax( pVwTask->m_pOptionsAmpHistogram->m_iChannel, &dMin, &dMax );
	
	//-- Iterate all data - add to histogram
	CHistogram * pHist = new CHistogram( pVwTask->m_pOptionsAmpHistogram->m_iBins, dMin, (dMax-dMin)/pVwTask->m_pOptionsAmpHistogram->m_iBins );
	pHist->SetTitles( "Amplitude Histogram", "Conductance", "Event Count" );

	if( pSet->GetFirst() )
		do { 
			int iSize=pSet->CurrentSize();
			pHist->AddData( iSize, pSet->m_adData );
			} while( pSet->GetNext() );
	
	//---- Send Histogram to main thread 
	pSet->m_pData->SetStatus(0);
	
	PostMessage( GetParent(GetClientWin()), WM_COMMAND, WM_ADD_HISTOGRAM, (LPARAM) pHist );	
	
	PostMessage( (HWND)pVwTask->m_hDlg, WM_TASKCOMPLETE, pVwTask->m_bCancelled?1:0, 0 );
	return -1;
	}
